/*
Este programa controla uma rede de terminais RS-485 com comutadora paralela,
atravs da Dll Wtechlpt.dll. Sistemas Operacionais Win2000 e XP ou superior,
no permitem acesso direto a porta paralela, para estes S.O. deve-se instalar
o Driver port95nt, sendo que para funcione de forma correta, deve-se estar Logado
como "Administrador" e com "Senha".

Nota: o mesmo sistema que comunica com a comutadora paralela (via Dll), tambm
pode se comunicar com Terminais TCP/IP, basta trocar a Dll e configurar um
arquivo .ini.
*/

#include "hbdll.ch"

FUNCTION Main( )

PRIVATE Qtdterm  := 31 && Quantidade de terminais 
PRIVATE tecla    := '' && Tecla digitada

** Arrays, 1 posio para cada terminal
PRIVATE statusLPT[ 32 ]    // Flag de impressao de paralela
PRIVATE statusCOM[ 32 ]    // Flag de impressao de serial
PRIVATE pikture[ 32 ]      // Picture esperada
PRIVATE waitkbd[ 32 ]      // Flag de espera de digitacao
PRIVATE teclado[ 32 ]      // Buffer de teclado
PRIVATE pospic[ 32 ]       // posio dentro da picture que devemos receber
PRIVATE pinpos[ 32 ]       // posio de entrada do buffer de paralela
PRIVATE poutpos[ 32 ]      // posio de saida do buffer de paralela
PRIVATE sinpos[ 32 ]       // posio de entrada do buffer de serial
PRIVATE soutpos[ 32 ]      // posio de saida do buffer de serial
PRIVATE estado[ 32 ]       // Estado de execucao do programa
PRIVATE proximo_estado[ 32 ]       // Estado de execucao do programa
PRIVATE pprinter[ 32 ]       // Buffer de impresso paralela		
PRIVATE sprinter[ 32 ]       // Buffer de impresso serial		

** variveis de aplicao
PRIVATE comanda[ 32 ]
PRIVATE produto[ 32 ]
PRIVATE quantidade[ 32 ]
PRIVATE usuario[ 32 ]


Cls

@ 00,00 Say Space(80) Color "7/7"
@ 24,00 Say Space(80) Color "7/7"

@ 00,00 Say " Terminais LPT Xharbour - v1.0" Color "0/7"
@ 24,00 Say " Pressione ESC para finalizar..." Color "0/7"

// O parmetro informado na funo ConfigLpt est fixo, deixar o valor
// configurvel no sistema, endereo da LPT e Timeout
 
If ConfigLpt(0x378,500) = 0
	@ 05,00 Say "Erro ao iniciar sistema! Pressine ESC para fechar."
	DO WHILE inkey() # chr(27) // Sai do programa
	ENDDO	
	QUIT
EndIf


// INICIALIZAO DOS TERMINAIS
For i = 1 To Qtdterm

    estado[ i ]   := 0 
    waitkbd[ i ]   := 0
    pinpos[ i ]    := 1
    poutpos[ i ]   := 1
    sinpos[ i ]    := 1
    soutpos[ i ]   := 1
    statusCOM[ i ] := 2
    statusLPT[ i ] := 2

    comanda[ i ]   := ""
    produto[ i ]   := ""
    quantidade[ i ]:= "" 	
    teclado[ i ]   := "" 
     
    pprinter[ i ]    := ""
    Gclear(i)
    Gclear(i)
Next

DO WHILE inkey() # chr(27) // Sai do programa

	For i = 1 To Qtdterm
		Trataterminais( i )
	Next

ENDDO

GTermina()
**
** FIM DA ROTINA PRINCIPAL
**


// PRINCIPAL ROTINA DO PROGRAMA
Static FUNCTION Trataterminais( numterm )

GflushCom( numterm ) // chama o descarregador de impresso na serial
GflushPrn( numterm ) // chama o descarregador de impresso na paralela

do case

	case estado[ numterm ] = 0
	     Gclear(numterm)
	     Gclear(numterm)	
             Gdisplay( "USUARIO:",numterm ) 
     	    // Gget ("AAAAAAAAAAAAAAAAAA",numterm) // Alfa apenas
	     Gget ("9999",numterm) // numero apenas
	     estado[ numterm ]:=1



	case estado[ numterm ] = 1
	     If Gtrtecla( numterm )
		 If teclado[ numterm ] == CHR(127) .Or. teclado[ numterm ] == ""      // teclado ENTER ou DEL sem digitao
			estado[ numterm ]:= 0
		 Else                              // se passou pelo GtrTecla  porque os dados foram recebidos
			estado[ numterm ]:= 2
			usuario[ numterm ]:= teclado[ numterm ]
		 Endif
	     Endif 		


	case estado[ numterm ] = 2
	     Gclear(numterm)
   	     Gdisplay( "SENHA:",numterm )
     	     Gget ("****",numterm)
	     estado[ numterm ]:=3


	case estado[ numterm ] = 3
	     If Gtrtecla( numterm )
		 If teclado[ numterm ] == CHR(127) .Or. teclado[ numterm ] == ""
			estado[ numterm ]:= 0
		 Else
			if teclado[ numterm ] == "1234"  // Neste ponto faria acesso ao BD para verificar se senha correta
				estado[ numterm ]:= 4				
			Else
				Gclear(numterm)
		   	        Gdisplay( "Senha invalida!",numterm )
				Gposcur( 2, 0, numterm )
				Gdisplay( "Senha Correta 1234",numterm )
     			        Gget ("X",numterm)
			        estado[ numterm ]:=99             // Prende a aplicao exibindo a msg "Senha Invalida"
				proximo_estado[ numterm ]:=2       // Quando pressionado uma tecla, retorna para estado 2

			Endif
		 Endif
	     Endif 		


	case estado[ numterm ] = 4            // Note que no exemplo, no estado PAR enviamos dados para o display do terminal
	     Gclear(numterm)
   	     Gdisplay( "Comanda:",numterm )   // e no estado IMPAR pegamos a digitao referente ao estado anterior (PAR)
     	     Gget ("9999",numterm)
	     estado[ numterm ]:=5


	case estado[ numterm ] = 5
	     If Gtrtecla( numterm )
		 If teclado[ numterm ] == CHR(127) .Or. teclado[ numterm ] == ""
			estado[ numterm ]:= 0
		 Else
			estado[ numterm ]:= 6
			comanda[ numterm ]:= teclado[ numterm ]
		 Endif
	     Endif 		


	case estado[ numterm ] = 6
	     Gposcur( 1, 0, numterm )
   	     Gdisplay( "Produto:",numterm )
     	     Gget ("9999",numterm)
	     estado[ numterm ]:=7


	case estado[ numterm ] = 7
	     If Gtrtecla( numterm )
		 If teclado[ numterm ] == CHR(127) .Or. teclado[ numterm ] == ""
			estado[ numterm ]:= 4
		 Else
			if teclado[ numterm ] == "1" // produto por peso
				estado[ numterm ]:= 10
				produto[ numterm ]:= teclado[ numterm ]
			Else
				estado[ numterm ]:= 8
				produto[ numterm ]:= teclado[ numterm ]	
			Endif
		 Endif
	     Endif 		


	case estado[ numterm ] = 8
	     Gclear( numterm )
   	     Gdisplay( "Quantidade:",numterm )
     	     Gget ("9999.999",numterm)
	     estado[ numterm ]:=9

	case estado[ numterm ] = 9
	     If Gtrtecla( numterm )
		 If teclado[ numterm ] == CHR(127) .Or. teclado[ numterm ] == ""
			estado[ numterm ]:= 6
		 Else
			estado[ numterm ]:= 12
			quantidade[ numterm ]:= teclado[ numterm ]
		 Endif
	     Endif



	case estado[ numterm ] = 10
	     Gclear( numterm )
   	     Gdisplay( "Aguardando peso...",numterm )
	     sprint(CHR(5),numterm)		
     	     Gget (CHR(3),numterm)
	     estado[ numterm ]:=11


	case estado[ numterm ] = 11
	     If Gtrtecla( numterm )
		If teclado[ numterm ] == CHR(127) .Or. teclado[ numterm ] == ""
		estado[ numterm ]:= 8
		 Else
		   estado[ numterm ]:= 12
		   quantidade[ numterm ]:= teclado[ numterm ]
	     	Endif
  	    Endif


	case estado[ numterm ] = 12
	     Gclear(numterm)
   	     Gdisplay( "     >>> Resumo da Comanda " + comanda[ numterm ] + " <<<",numterm )
	     Gposcur( 1, 0, numterm )
   	     Gdisplay( "Produto:" + produto[ numterm ],numterm )
	     Gposcur( 1, 24, numterm )
   	     Gdisplay( "Quantidade:" + quantidade[ numterm ],numterm )
	
	     pprint("Terminal:" + alltrim(str(numterm)) + chr(10) + chr(13),numterm)	
	     pprint("Comanda:" + comanda[ numterm ] + chr(10) + chr(13),numterm)	
	     pprint("Produto:" + produto[ numterm ] + chr(10) + chr(13),numterm)	
	     pprint("Quantidade:" + quantidade[ numterm ] + chr(10) + chr(13),numterm)	
	     pprint("-------------------------------------" + chr(10) + chr(13),numterm)	

     	     Gget ("X",numterm)
	     estado[ numterm ]:=99
	     proximo_estado[ numterm ]:=4

	case estado[ numterm ] = 99
	     If Gtrtecla( numterm )
		     estado[ numterm ]:=proximo_estado[ numterm ]
	     Endif 		
endcase

RETURN .F.



// Apaga o display do terminal
Static Function Gclear(tm)
	Dll_Clear(tm)
Return Nil


// Posiciona o cursor no display do terminal.
// Valores validos: Linha 0 e 1
//                 Coluna 0 a 39
Static Function Gposcur( linha, coluna, tm )
	Dll_Poscur(tm,linha,coluna)
Return Nil


// Envia uma mensagem para o display do terminal
Static Function Gdisplay( dados, tm )
	Dll_Display(tm,dados)
Return Nil


// Funcao de tratamento do teclado do terminal.
// Pede tecla e faz a consistencia com a picture
// solicitada na funcao GGET, aceitando ou rejeitando
// o que for digitado no terminal.
// Tambem faz o tratamento do 'DEL' do terminal,
// limpando o campo quando tem algum caracter digitado
// ou retornando ESC quando nao tinha nada digitado.
// O retorno desta funcao sera:
//          0 - quando a picture solicitada no
//               ultimo gget nao tiver sido digitada.
//          1 - quando a picture tiver sido digitada
//              completamente.

/*
Static Function Gtrtecla(tm)
*
** Tecla digitada **
*
Local gpict  := ''

tecla = chr(Dll_Get(tm))
If tecla = Chr(0)
	return .F.
EndIf

Do case
   case tecla = Chr(127) && se a existe tecla para tratar
        If pospic[ tm ] = 1
           teclado[ tm ] = Chr(127)
           waitkbd[ tm ] = 0
           return .T.
        Else
           While pospic[ tm ] > 1
                 tecla = Chr(8)  // Backspace
                 Gecho(tm)
                 pospic[ tm ] = pospic[ tm ] - 1
           End
           teclado[ tm ] = ""
           return .F.
        EndIf
   case tecla = Chr(8)
        If pospic[ tm ] > 1
           gpict = Subs( pikture[ tm ], pospic[ tm ] - 1, 1 )
           If gpict = "/" .Or. gpict = "."
              Gecho(tm)
              pospic[ tm ] = pospic[ tm ] - 1
           EndIf
           pospic[ tm ] = pospic[ tm ] - 1
           teclado[ tm ] = SUBS( teclado[ tm ], 1, pospic[ tm ] - 1 )
           Gecho(tm)
        EndIf
        return .F.
   case tecla = Chr(13)
        waitkbd[ tm ] = 0
        return .T.
Endcase

   gpict = SUBS( pikture[ tm ], pospic[ tm ], 1 )

   DO CASE
      CASE gpict = Chr(3)
	   If tecla = Chr(3)
	        waitkbd[ tm ] = 0
        	return .T.
	   Else
		If (tecla # Chr(2)) .And. (tecla # Chr(3))
			teclado[ tm ] = teclado[ tm ] + tecla
		EndIf
	   EndIf	           

      CASE gpict = "X"
           teclado[ tm ] = teclado[ tm ] + tecla
           pospic[ tm ] = pospic[ tm ] + 1
           Gecho(tm)
      CASE gpict = "9"
           If ( tecla >= "0" .And. tecla <= "9" ) .Or. (tecla = ".") .Or. (tecla = "/")
              If tecla = "."
                 ajusta_ponto(tm)
              Else
                 teclado[ tm ] = teclado[ tm ] + tecla
                 pospic[ tm ]  = pospic[ tm ]  + 1
                 Gecho(tm)
              EndIf
           EndIf
      CASE gpict = "A"
           If (tecla >= "A" .And. tecla <= "Z") .or. (tecla = " ")
              teclado[ tm ] = teclado[ tm ]  + tecla
              pospic[ tm ]  = pospic[ tm ]  + 1
              Gecho(tm)
           EndIf
      CASE gpict = "*"
           teclado[ tm ] = teclado[ tm ] + tecla
           pospic[ tm ] = pospic[ tm ] + 1
           tecla = "*"
           Gecho(tm)
   Endcase
  
   tamanho = Len( pikture[ tm ] ) + 1
   gpict = SUBS( pikture[ tm ], pospic[ tm ], 1 )
  
   If tamanho = pospic[ tm ]
         waitkbd[ tm ] = 0
         return .T.        
   Endif
	
   DO CASE
           CASE gpict = "/"
                tecla = "/"
                pospic[ tm ] = pospic[ tm ] + 1
                Gecho(tm)
           CASE gpict = "."
                tecla = "."
                pospic[ tm ] = pospic[ tm ] + 1
                Gecho(tm)
        otherwise
	 	return .F.
   Endcase

return .F.
*/


****************************
Static Function Gtrtecla(tm)
****************************
** Tecla digitada **
Local gpict  := ''
tecla = chr(Dll_Get(tm))
If tecla = Chr(0)
	return .F.
EndIf
Do case
   case tecla = Chr(127) && se a existe tecla para tratar
        If pospic[ tm ] = 1
           teclado[ tm ] = Chr(127)
           waitkbd[ tm ] = 0
           return .T.
        Else
           While pospic[ tm ] > 1
                 tecla = Chr(8)  // Backspace
                 Gecho(tm)
                 pospic[ tm ] = pospic[ tm ] - 1
           End
           teclado[ tm ] = ""
           return .F.
        EndIf
   case tecla = Chr(8)
        If pospic[ tm ] > 1
           gpict = Subs( pikture[ tm ], pospic[ tm ] - 1, 1 )
           If gpict = "/" .Or. gpict = "."
              Gecho(tm)
              pospic[ tm ] = pospic[ tm ] - 1
           EndIf
           pospic[ tm ] = pospic[ tm ] - 1
           teclado[ tm ] = SUBS( teclado[ tm ], 1, pospic[ tm ] - 1 )
           Gecho(tm)
        EndIf
        return .F.
   case tecla = Chr(13)
        waitkbd[ tm ] = 0
        return .T.
Endcase
gpict = SUBS( pikture[ tm ], pospic[ tm ], 1 )
DO CASE
   CASE gpict = Chr(3)
	   If tecla == Chr(3)
			//	teclado[ tm ] = teclado[ tm ] + tecla
			waitkbd[ tm ] = 0
	      return .T.
	   Else
			If (tecla # Chr(2)) .And. (tecla # Chr(3))
				teclado[ tm ] = teclado[ tm ] + tecla
			endif
			return .F.
	   EndIf	           
                                
	CASE gpict = "X"
        teclado[ tm ] = teclado[ tm ] + tecla
        pospic[ tm ] = pospic[ tm ] + 1
        Gecho(tm)
   
	CASE gpict = "9"
        If ( tecla >= "0" .And. tecla <= "9" ) .Or. (tecla = ".") .Or. (tecla = "/")
           If tecla = "."
              ajusta_ponto(tm)
           Else
              teclado[ tm ] = teclado[ tm ] + tecla
              pospic[ tm ]  = pospic[ tm ]  + 1
              Gecho(tm)
           EndIf
        EndIf
   
	CASE gpict = "A"
        If (tecla >= "A" .And. tecla <= "Z") .or. (tecla = " ")
           teclado[ tm ] = teclado[ tm ]  + tecla
           pospic[ tm ]  = pospic[ tm ]  + 1
           Gecho(tm)
        EndIf

   CASE gpict = "*"
        teclado[ tm ] = teclado[ tm ] + tecla
        pospic[ tm ] = pospic[ tm ] + 1
        tecla = "*"
        Gecho(tm)
Endcase
  
tamanho = Len( pikture[ tm ] ) + 1
gpict = SUBS( pikture[ tm ], pospic[ tm ], 1 )
If tamanho = pospic[ tm ]
   waitkbd[ tm ] = 0
   return .T.        
Endif                                            

DO CASE
   CASE gpict = "/"
        tecla = "/"
        pospic[ tm ] = pospic[ tm ] + 1
        Gecho(tm)
   CASE gpict = "."
        tecla = "."
        pospic[ tm ] = pospic[ tm ] + 1
        Gecho(tm)
   otherwise
   	  return .F.
Endcase

return .F.


// Envia um caracter para o display do terminal
Static Function Gecho(tm)
	Dll_Display(tm,tecla)    
RETURN NIL


// Funcao de ajuste da posio do ponto dentro de
// uma picture numerica.
Static Function ajusta_ponto(tm)

Local sppic:=posponto:=slen:=pponto:=0
Local strdisp:=''

slen = Len( teclado[ tm ] )
posponto = 1
*
While Subs( pikture[ tm ], posponto, 1 ) <> "."
      posponto += 1
      If posponto >= Len( pikture[ tm ] )
         RETURN NIL
      EndIf
enddo
*
sppic   = posponto - 1 - Len( teclado[ tm ] )
strdisp = ""
*
While sppic > 0
   strdisp += " "
   sppic   -= 1
endDO
*
strdisp += teclado[ tm ] 
sppic    = pospic[ tm ] 
*
While sppic >= 1
   tecla  = Chr(8)
   Gecho(term)
   sppic -= 1
endDO
*
pospic[ tm ] = posponto
Gdisplay( strdisp,tm )
teclado[ tm ] = strdisp

RETURN NIL


// Funcao de pedido de entrada de dados.
// As pictures validas sao:
//     9 - caracter numerico
//     A - caracter alfabetico
//     X - qualquer caracter
//     . - decimal ( so em campo numerico )
//     / - separador de campo( so em campo numerico )

Static Function Gget( formato,tm )

If waitkbd[ tm ] = 0
   pikture[ tm ] = formato  // guarda o formato
   pospic[ tm ]  = 1        // posiciona o ponteiro na 1a. posio
   teclado[ tm ] = ""       // limpa o buffer de entrada
   waitkbd[ tm ] = 1        // liga o flag de espera de picture
   Gget = 1
Else
   Gget = 0
EndIf

RETURN NIL


// ESSSA FUNCAO FINALIZA OS TERMINAIS
// INFORMANDO QUE O SISTEMA ESTA DESATIVADO

Static Function GTermina()

Local i

For i = 1 To Qtdterm
    Gclear(i)
    Gdisplay ("Sistema finalizado...",i)
Next
Dll_Close()    
QUIT

RETURN NIL


// FUNCAO para acumular dados de impresso paralela
Static Function pprint(dados, tm)

    pinpos[ tm ] = pinpos[ tm ] + Len(dados)
    pprinter[ tm ] = pprinter[ tm ] + dados
    
RETURN NIL


// FUNCAO para acumular dados de impresso serial
Static Function sprint(dados, tm)

    sinpos[ tm ] = sinpos[ tm ] + Len(dados)
    sprinter[ tm ] = sprinter[ tm ] + dados
    
RETURN NIL


// FUNCAO para impresso na paralela
Static Function GflushPrn(tm)
	Local i
	Local dado := ''
	Local retorno := 0

	If pinpos[ tm ] <> poutpos[ tm ] //se tiver dados a serem impressos
		i = 0
		while (i < 30) .And. (pinpos[ tm ] <> poutpos[ tm ])
			dado = Subs( pprinter[ tm ], poutpos[ tm ], 1 )
			retorno = Dll_Acesso(chr(254) + STRZERO( tm, 2, 0 ) + "I" + dado)
			If retorno # chr(0) //se conseguiu escrever o byte, incrementa ponteiro
				poutpos[ tm ] = poutpos[ tm ] + 1
			EndIf
			i = i + 1			
		endDO

	Else
		pprinter[ tm ] = ""
		poutpos[ tm ] = 1
	        pinpos[ tm ] = 1
	EndIf			
		        
RETURN NIL

// FUNCAO para impresso na serial
Static Function GflushCom(tm)
	Local i
	Local dado := ''
	Local retorno := 0

	If sinpos[ tm ] <> soutpos[ tm ] //se tiver dados a serem impressos
		i = 0
		while (i < 30) .And. (sinpos[ tm ] <> soutpos[ tm ])
			dado = Subs( sprinter[ tm ], soutpos[ tm ], 1 )
			retorno = Dll_Acesso(chr(254) + STRZERO( tm, 2, 0 ) + "R" + dado)
			If retorno # chr(0) //se conseguiu escrever o byte, incrementa ponteiro
				soutpos[ tm ] = soutpos[ tm ] + 1
			EndIf
			i = i + 1			
		endDO

	Else
		sprinter[ tm ] = ""
		soutpos[ tm ] = 1
	        sinpos[ tm ] = 1
	EndIf			


RETURN NIL


// DECLARAO DA DLL WTECHLPT.DLL

DECLARE Integer ConfigLpt in Wtechlpt.dll Integer Porta, Integer Timeout
DECLARE FUNCTION Dll_Clear in Wtechlpt.dll Integer Terminal
DECLARE FUNCTION Dll_Close in Wtechlpt.dll
DECLARE FUNCTION Dll_PosCur in Wtechlpt.dll Integer Terminal, Integer Linha, Integer Coluna
DECLARE FUNCTION Dll_Display in Wtechlpt.dll Integer Terminal, String Dados
DECLARE FUNCTION Dll_Acesso in Wtechlpt.dll String Dados
DECLARE Integer Dll_Get in Wtechlpt.dll Integer Terminal

